﻿Imports System.IO
Imports System.Drawing
Imports IWshRuntimeLibrary

Public Class IconsAndPaths
    Public IconsPathsDi As New Dictionary(Of String, String())

    Public Function GetIconsAndPaths() As Dictionary(Of String, String())
        Dim path As String = Environment.GetFolderPath(Environment.SpecialFolder.CommonStartMenu) & _
                            "\Programs"
        Dim startMenuProgDir As New DirectoryInfo(path)

        If (startMenuProgDir.Exists <> True) Then
            Dim dirPath As String = Environment.GetFolderPath(Environment.SpecialFolder.StartMenu) & _
                                    "\Programs"
            startMenuProgDir = New DirectoryInfo(dirPath)
        End If
        Dim shell As New WshShell

        CreateIconsDirectory()

        For Each fi As FileInfo In startMenuProgDir.GetFiles
            If (fi.Extension = ".lnk") Then
                ' The length of the file's name alone minus .lnk
                Dim nameLength As Integer = fi.Name.Length - 4
                ' Name to display in UserControl
                Dim displayName As String = fi.Name.Substring(0, nameLength)
                ' Copy of shortcut
                Dim link As IWshShortcut = CType(shell.CreateShortcut(fi.FullName),  _
                                                IWshShortcut)

                Dim potentialExePath As String = link.TargetPath
                Dim potentialExe As New FileInfo(potentialExePath)

                If (potentialExe.Extension = ".exe") Then
                    Dim tileIconPath As String = Environment.CurrentDirectory & _
                                                "\WPF Metro Icons\" & _
                                                displayName & ".png"
                    Try
                        Dim ico As System.Drawing.Icon = _
                            System.Drawing.Icon.ExtractAssociatedIcon(potentialExePath)
                        ico.ToBitmap().Save(tileIconPath, Imaging.ImageFormat.Png)

                        AddToDictionary(displayName, tileIconPath, potentialExePath)
                    Catch ex As FileNotFoundException
                        Exit Try
                    End Try

                End If
            End If
        Next

        ' Get icons for .lnk in ...Start Menu\Programs\...
        For Each di As DirectoryInfo In startMenuProgDir.GetDirectories()
            For Each fi As FileInfo In di.GetFiles()
                If (fi.Extension = ".lnk") Then
                    ' The length of the file's name alone minus .lnk
                    Dim nameLength As Integer = fi.Name.Length - 4
                    ' Name to display in UserControl
                    Dim displayName As String = fi.Name.Substring(0, nameLength)
                    ' Avoid install and uninstall files
                    If (displayName.Contains("install") <> True) Then
                        Dim link As IWshShortcut = CType(shell.CreateShortcut(fi.FullName),  _
                                                        IWshShortcut)
                        Dim potentialExePath As String = link.TargetPath

                        If (potentialExePath.Contains(".exe")) Then
                            Dim tileIconPath As String = Environment.CurrentDirectory & _
                                                "\WPF Metro Icons\" & _
                                                displayName & ".png"
                            Try
                                Dim ico As Icon = Icon.ExtractAssociatedIcon(potentialExePath)
                                ico.ToBitmap().Save(tileIconPath, Imaging.ImageFormat.Png)

                                CheckMSOfficeApps(displayName, tileIconPath)

                                AddToDictionary(displayName, tileIconPath, potentialExePath)

                            Catch ex As FileNotFoundException
                                Exit Try
                            Catch ex As ArgumentException
                                Exit Try
                            End Try

                        End If
                    End If
                End If
            Next
        Next

        Return IconsPathsDi
    End Function

    Private Sub AddToDictionary(ByVal displayName As String, ByVal tileIconPath As String, _
                               ByVal exePath As String)
        If Not IconsPathsDi.ContainsKey(displayName) Then
            IconsPathsDi.Add(displayName, New String() {tileIconPath, exePath})
        End If
    End Sub

    Private Sub CheckMSOfficeApps(ByVal app As String, ByVal tileIconPath As String)
        If (app.Contains("Microsoft Office Access")) Then
            AddToDictionary(app, tileIconPath, "MSACCESS.EXE")
        ElseIf (app.Contains("Microsoft Office Excel")) Then
            AddToDictionary(app, tileIconPath, "EXCEL.EXE")
        ElseIf (app.Contains("Microsoft Office InfoPath")) Then
            AddToDictionary(app, tileIconPath, "INFOPATH.EXE")
        ElseIf (app.Contains("Microsoft Office OneNote")) Then
            AddToDictionary(app, tileIconPath, "ONENOTEM.EXE")
        ElseIf (app.Contains("Microsoft Office Outlook")) Then
            AddToDictionary(app, tileIconPath, "OUTLOOK.EXE")
        ElseIf (app.Contains("Microsoft Office PowerPoint")) Then
            AddToDictionary(app, tileIconPath, "POWERPNT.EXE")
        ElseIf (app.Contains("Microsoft Office Publisher")) Then
            AddToDictionary(app, tileIconPath, "MSPUB.EXE")
        ElseIf (app.Contains("Microsoft Office Word")) Then
            AddToDictionary(app, tileIconPath, "WINWORD.EXE")
        Else
            Exit Sub
        End If
    End Sub

    Private Sub CreateIconsDirectory()
        Dim dir As String = Environment.CurrentDirectory & "\WPF Metro Icons"
        If (Directory.Exists(dir)) Then
            Dim di As New DirectoryInfo(dir)
            For Each fi As FileInfo In di.GetFiles
                fi.Delete()
            Next
        Else
            Directory.CreateDirectory(dir)
        End If
    End Sub
End Class
